"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
path.proto
Contains toolpath motion primitives.

Note that we use an *implicit unit system*
of meters-kilograms-seconds everywhere
and values other than `mks` are invalid!
"""
import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import kerfed.protos.common.v1.cots_pb2
import kerfed.protos.common.v1.model_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _ToolShape:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _ToolShapeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_ToolShape.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    TOOL_SHAPE_UNSPECIFIED: _ToolShape.ValueType  # 0
    TOOL_SHAPE_SQUARE_MILL: _ToolShape.ValueType  # 1
    """A cylinder."""
    TOOL_SHAPE_BALL_MILL: _ToolShape.ValueType  # 2
    """A cylinder with a hemispherical end."""
    TOOL_SHAPE_DRILL: _ToolShape.ValueType  # 3
    """A drill bit."""

class ToolShape(_ToolShape, metaclass=_ToolShapeEnumTypeWrapper): ...

TOOL_SHAPE_UNSPECIFIED: ToolShape.ValueType  # 0
TOOL_SHAPE_SQUARE_MILL: ToolShape.ValueType  # 1
"""A cylinder."""
TOOL_SHAPE_BALL_MILL: ToolShape.ValueType  # 2
"""A cylinder with a hemispherical end."""
TOOL_SHAPE_DRILL: ToolShape.ValueType  # 3
"""A drill bit."""
global___ToolShape = ToolShape

@typing_extensions.final
class ToolParameters(google.protobuf.message.Message):
    """Material specific parameters which can be used for path generation.
    Parameters are in units that are supplied from tooling suppliers
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MATERIAL_ID_FIELD_NUMBER: builtins.int
    SURFACE_FEET_PER_MINUTE_FIELD_NUMBER: builtins.int
    INCH_PER_TOOTH_FIELD_NUMBER: builtins.int
    MAXIMUM_RPM_FIELD_NUMBER: builtins.int
    RADIAL_DEPTH_OF_CUT_FIELD_NUMBER: builtins.int
    IS_CARBIDE_FIELD_NUMBER: builtins.int
    FLUTES_FIELD_NUMBER: builtins.int
    USE_ROUGH_FIELD_NUMBER: builtins.int
    USE_FINISH_FIELD_NUMBER: builtins.int
    material_id: builtins.str
    """The material ID this tool can be used for"""
    @property
    def surface_feet_per_minute(self) -> kerfed.protos.common.v1.model_pb2.Interval:
        """"surface feet per minute"
        The "units of art" for how the rotational speed of
        the end mill should be correlated to the movement speed.
        Basically if you increase the spindle speed you can increase
        the movement speed to keep the amount of material removed
        per tooth of the end mill the same.
        """
    @property
    def inch_per_tooth(self) -> kerfed.protos.common.v1.model_pb2.Interval:
        """Inch per tooth values."""
    maximum_rpm: builtins.float
    """The cap for how fast this tool should be run."""
    radial_depth_of_cut: builtins.float
    """The percentage of the radius which should be cut per pass.
    i.e. for a 1" diameter end mill `radial_depth_of_cut=0.12`
    would mean steps of 12% of the radius or 0.06" per step.
    """
    is_carbide: builtins.bool
    """Is this tool carbide or HSS?"""
    flutes: builtins.int
    """how many flutes does this tool have?"""
    use_rough: builtins.bool
    """Should this be used for "roughing," or large volume removal"""
    use_finish: builtins.bool
    """Should this tool be used for finish passes, or exactly touching
    the surface of the finish part.
    """
    def __init__(
        self,
        *,
        material_id: builtins.str = ...,
        surface_feet_per_minute: kerfed.protos.common.v1.model_pb2.Interval | None = ...,
        inch_per_tooth: kerfed.protos.common.v1.model_pb2.Interval | None = ...,
        maximum_rpm: builtins.float = ...,
        radial_depth_of_cut: builtins.float = ...,
        is_carbide: builtins.bool = ...,
        flutes: builtins.int = ...,
        use_rough: builtins.bool = ...,
        use_finish: builtins.bool = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["inch_per_tooth", b"inch_per_tooth", "surface_feet_per_minute", b"surface_feet_per_minute"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["flutes", b"flutes", "inch_per_tooth", b"inch_per_tooth", "is_carbide", b"is_carbide", "material_id", b"material_id", "maximum_rpm", b"maximum_rpm", "radial_depth_of_cut", b"radial_depth_of_cut", "surface_feet_per_minute", b"surface_feet_per_minute", "use_finish", b"use_finish", "use_rough", b"use_rough"]) -> None: ...

global___ToolParameters = ToolParameters

@typing_extensions.final
class Tool(google.protobuf.message.Message):
    """Describes a tool used to cut a path."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SHAPE_FIELD_NUMBER: builtins.int
    INDEX_FIELD_NUMBER: builtins.int
    PARAMETERS_FIELD_NUMBER: builtins.int
    RADIUS_FIELD_NUMBER: builtins.int
    LENGTH_CUT_FIELD_NUMBER: builtins.int
    LENGTH_TOTAL_FIELD_NUMBER: builtins.int
    SUPPLIERS_FIELD_NUMBER: builtins.int
    SPEED_FEED_FIELD_NUMBER: builtins.int
    SPEED_RPM_FIELD_NUMBER: builtins.int
    shape: global___ToolShape.ValueType
    """Is this a square end mill, ball-end mill, etc."""
    index: builtins.int
    """When stored in a tool magazine, what is the index?"""
    @property
    def parameters(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ToolParameters]:
        """The materials this tool is valid for and values that can
        be used to calculate the "speeds and feeds" for each material.
        """
    radius: builtins.float
    """The cutting radius in meters."""
    length_cut: builtins.float
    """What length of the tool can cut sideways."""
    length_total: builtins.float
    """What is the total length of the tool from spindle to tip."""
    @property
    def suppliers(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[kerfed.protos.common.v1.cots_pb2.CotsMatch]:
        """Information about where to get this tool including supplier and price."""
    speed_feed: builtins.float
    """If passed override linear feed rate from `ToolParameters`
    units are in mm/min and will be passed to the `F` g-code.
    """
    speed_rpm: builtins.float
    """If passed override spindle speed from `ToolParameters`
    Will be passed to the `S` g-code
    """
    def __init__(
        self,
        *,
        shape: global___ToolShape.ValueType = ...,
        index: builtins.int = ...,
        parameters: collections.abc.Iterable[global___ToolParameters] | None = ...,
        radius: builtins.float = ...,
        length_cut: builtins.float = ...,
        length_total: builtins.float = ...,
        suppliers: collections.abc.Iterable[kerfed.protos.common.v1.cots_pb2.CotsMatch] | None = ...,
        speed_feed: builtins.float = ...,
        speed_rpm: builtins.float = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["index", b"index", "length_cut", b"length_cut", "length_total", b"length_total", "parameters", b"parameters", "radius", b"radius", "shape", b"shape", "speed_feed", b"speed_feed", "speed_rpm", b"speed_rpm", "suppliers", b"suppliers"]) -> None: ...

global___Tool = Tool
